Last Comment Bug 735749 - No back button in awesomescreen on Maemo 6 Harmattan (N9)
: No back button in awesomescreen on Maemo 6 Harmattan (N9)
Status: RESOLVED FIXED
: regression
Product: Fennec Graveyard
Classification: Graveyard
Component: General (show other bugs)
: Firefox 9
: ARM MeeGo
: -- normal (vote)
: Firefox 14
Assigned To: Matt Brubeck (:mbrubeck)
:
Mentors:
Depends on:
Blocks: 680212
  Show dependency treegraph
 
Reported: 2012-03-14 10:22 PDT by Maurice
Modified: 2012-04-13 15:18 PDT (History)
8 users (show)
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
patch (840 bytes, patch)
2012-03-30 10:02 PDT, Matt Brubeck (:mbrubeck)
no flags Details | Diff | Splinter Review
patch v2 (1.40 KB, patch)
2012-03-30 11:23 PDT, Matt Brubeck (:mbrubeck)
mark.finkle: review+
akeybl: approval‑mozilla‑aurora+
akeybl: approval‑mozilla‑beta+
akeybl: approval‑mozilla‑esr10+
Details | Diff | Splinter Review

Description Maurice 2012-03-14 10:22:50 PDT
There is no back button for firefox for N9 when entering a web in the status bar and the only way to go back is to click on a web and close the tab .
Comment 1 Andreea Pod 2012-03-30 05:11:30 PDT
Unfortunately, Firefox is no more supported for MeeGo.
Comment 2 Shmerl 2012-03-30 07:44:25 PDT
There is a non obvious way to go back from the bookmarks All Pages, Bookmarks, History etc. UI. in the Harmattan XUL build. Just tap on the thin area right above the address bar. It should take you back to the previous screen.

In general, please don't mark these bugs as WONTFIX until you know for sure that this change is rejected out real reasons. Linux XUL builds aren't officially supported, but community still works on them.
Comment 3 Matt Brubeck (:mbrubeck) 2012-03-30 10:00:37 PDT
There's a button here to return from the urlbar:
https://hg.mozilla.org/mozilla-central/file/8bf3120ed0f8/mobile/xul/chrome/content/browser.xul#l272

But it is hidden by default and shown only on Maemo, but *not* on Maemo 6 (Harmattan):
https://hg.mozilla.org/mozilla-central/file/8bf3120ed0f8/mobile/xul/themes/core/browser.css#l110

The best fix might be to change that line to "%ifndef ANDROID" should show the button on all non-Android platforms...
Comment 4 Matt Brubeck (:mbrubeck) 2012-03-30 10:02:55 PDT
Created attachment 610922 [details] [diff] [review]
patch

I don't have a Harmattan device to test this patch.
Comment 5 Shmerl 2012-03-30 10:26:35 PDT
I tested the patch - it adds the close button which closes the browser which you tap it. The problem was not to close it, but to return back to the previous screen though.
Comment 6 Matt Brubeck (:mbrubeck) 2012-03-30 10:29:31 PDT
Comment on attachment 610922 [details] [diff] [review]
patch

Oh right, I'm getting my toolbar buttons mixed up.  Sorry.

There's a button to close the preferences panel on Maemo, but there doesn't seem to be any similar button to close the awesomescreen.  How was this handled on previous Maemo versions?
Comment 7 Matt Brubeck (:mbrubeck) 2012-03-30 10:34:41 PDT
(In reply to Shmerl from comment #5)
> I tested the patch - it adds the close button which closes the browser which
> you tap it. The problem was not to close it, but to return back to the
> previous screen though.

Actually, it *should* return to the previous screen if you tap the button while the awesomescreen (All Pages / Bookmarks / History screen) is visible.

Perhaps on Maemo 6, Fennec should display the button only when the awesomescreen is visible, and hide it otherwise.
Comment 8 Shmerl 2012-03-30 10:40:34 PDT
Well, in my case it just closes the browser. It doesn't return to the previous screen. I did a dirty hack test, just updates the browser.css inside the jar file adding this line:

#toolbar-main[fullscreen="true"] #tool-app-close {   visibility: visible; }

Anyway, adding more buttons in such a narrow space isn't a good design approach.

Current method (taping on the small area above the address bar) works, but it's very not intuitive and non obvious. I noticed that long tap on the address bar brings out a context menu with "Paste" and "Paste & Go" entries. May be the "Back" entry can be placed there?
Comment 9 Matt Brubeck (:mbrubeck) 2012-03-30 11:23:49 PDT
Created attachment 610947 [details] [diff] [review]
patch v2

This was a regression from bug 680212.  The changes to the AwesomeScreen.activePanel setter made it pass "null" to BrowserUI.pushDialog.  This had no effect on Android, but on desktop and Maemo it breaks the showing of #tool-app-close button.

Bug 680212 also added a TapDown handler that closes the awesomescreen on TapDown "outside" of it.  When clicking on the close button, the awesomescreen would close in the TapDown handler, and then the button click would cause the app to quit (which explains the problem in comment 5).  This patch adds a line to make the close button be considered "inside" the awesomescreen.
Comment 10 Matt Brubeck (:mbrubeck) 2012-03-30 11:26:23 PDT
Note: I tested this patch on Android (including in tablet mode) as well as on desktop (which matches the Maemo behavior and styles).
Comment 11 Matt Brubeck (:mbrubeck) 2012-03-30 18:55:42 PDT
romaxa, should I ask for this to be backported to beta/aurora for Fx12/13?  Or perhaps you can just include it as a local patch in your Ovi store builds until it reaches release.

https://hg.mozilla.org/integration/mozilla-inbound/rev/44da25d479ef
Comment 12 Oleg Romashin (:romaxa) 2012-03-30 21:25:18 PDT
Let me check first, how it works on nightly build. Yep, it would be nice to backport it to sooner release after I test it. (don't like to keep patches for ovi builds)
Comment 13 Ed Morley [:emorley] 2012-03-31 19:20:57 PDT
https://hg.mozilla.org/mozilla-central/rev/44da25d479ef
Comment 14 Matt Brubeck (:mbrubeck) 2012-04-05 15:58:25 PDT
Comment on attachment 610947 [details] [diff] [review]
patch v2

[Approval Request Comment]
Regression caused by (bug #): bug 680212

User impact if declined: No discoverable way to exit the awesomescreen on Maemo.

Testing completed (on m-c, etc.): Landed on m-c about a week ago.

Risk to taking this patch (and alternatives if risky): This is a low-risk, 2-line patch that only touches XUL Fennec.  It has no visible effect on Android.  It's needed only for Firefox for Maemo/MeeGo, which is available to users through the Ovi Store.

String changes made by this patch: None.
Comment 15 Alex Keybl [:akeybl] 2012-04-09 12:56:18 PDT
Comment on attachment 610947 [details] [diff] [review]
patch v2

[Triage Comment]
Approved for Aurora 13 and Beta 12. Presumably we need this fix on the ESR too, so approving for that branch as well.
Comment 16 Matt Brubeck (:mbrubeck) 2012-04-09 13:26:14 PDT
https://hg.mozilla.org/releases/mozilla-beta/rev/f3d89dab29ca
https://hg.mozilla.org/releases/mozilla-aurora/rev/38b996dfb716

I don't think anyone is producing esr10 builds for Maemo or MeeGo, so I don't think there's any reason to land this patch there...
Comment 17 Matt Brubeck (:mbrubeck) 2012-04-09 13:34:11 PDT
Marking as "wontfix" for esr10, unless someone knows a reason to change that.

Note You need to log in before you can comment on or make changes to this bug.